## rizin-ghidra-plugin 0.7.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
set(PKG_CONFIG_USE_CMAKE_PREFIX_PATH True)

project(rz-ghidra)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

find_package(Rizin REQUIRED Core)

set(RIZIN_INSTALL_PLUGDIR "${Rizin_PLUGINDIR}" CACHE STRING "Directory to install rizin plugins into")

option(BUILD_CUTTER_PLUGIN "Build rz-ghidra plugin for Cutter" OFF)
option(BUILD_DECOMPILE_EXECUTABLE "Build \"decompile\" executable as used by Ghidra (not needed for rizin)" OFF)
option(BUILD_DECOMPILE_CLI_EXECUTABLE "Build REPL decompiler (not needed for rizin)" OFF)
option(BUILD_SLASPECS "Build Sleigh specs for architectures from Ghidra" ON)
option(BUILD_SLEIGH_PLUGIN "Build asm and analysis plugin to use sleigh as a disassembler in rizin" ON)
option(GENERATE_PARSERS "Re-generate all parsers with Bison/Flex instead of using pre-generated ones" OFF)

if (BUILD_CUTTER_PLUGIN)
	find_package(Cutter REQUIRED)
	set(CUTTER_INSTALL_PLUGDIR "${Cutter_USER_PLUGINDIR}" CACHE STRING "Directory to install Cutter plugin into")
endif()

if(CMAKE_VERSION VERSION_LESS "3.1")
	if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
		add_definitions(-std=c++11)
	endif()
else()
	set(CMAKE_CXX_STANDARD 11)
endif()

add_subdirectory(ghidra)
add_subdirectory(third-party)

set(PUBLIC_HEADERS
		src/rz_ghidra.h)

set(CORE_SOURCE
		src/core_ghidra.cpp
		src/RizinArchitecture.cpp
		src/RizinArchitecture.h
		src/RizinLoadImage.cpp
		src/RizinLoadImage.h
		src/RizinScope.cpp
		src/RizinScope.h
		src/RizinTypeFactory.cpp
		src/RizinTypeFactory.h
		src/RizinCommentDatabase.cpp
		src/RizinCommentDatabase.h
		src/CodeXMLParse.h
		src/CodeXMLParse.cpp
		src/ArchMap.h
		src/ArchMap.cpp
		src/RizinPrintC.h
		src/RizinPrintC.cpp
		src/RzCoreMutex.h
		src/RzCoreMutex.cpp
		src/PrettyXmlEncode.h
		src/PrettyXmlEncode.cpp
		src/rz_ghidra.h
		src/rz_ghidra_internal.h)

if(BUILD_SLEIGH_PLUGIN)
set(ASM_SOURCE
		src/SleighAsm.h
		src/SleighAsm.cpp
		src/SleighInstruction.h
		src/SleighInstruction.cpp
		src/asm_ghidra.cpp)

set(ANALYSIS_SOURCE
		src/SleighAsm.h
		src/SleighAsm.cpp
		src/SleighInstruction.h
		src/SleighInstruction.cpp
		src/SleighAnalysisValue.h
		src/SleighAnalysisValue.cpp
		src/analysis_ghidra.cpp)
endif()

add_library(core_ghidra SHARED ${CORE_SOURCE})
target_link_libraries(core_ghidra ghidra_libdecomp)
target_link_libraries(core_ghidra pugixml)
target_link_libraries(core_ghidra Rizin::Core)
set_target_properties(core_ghidra PROPERTIES
		OUTPUT_NAME core_ghidra
		PREFIX "")

configure_file(
	${PROJECT_SOURCE_DIR}/rz_ghidra.pc.in
	${PROJECT_BINARY_DIR}/rz_ghidra.pc
	@ONLY)

if(BUILD_CUTTER_PLUGIN)
	add_subdirectory(cutter-plugin)
endif()


if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
	string (REPLACE ";" " " LD_RPATH_STR "@loader_path")
else()
	string (REPLACE ";" " " LD_RPATH_STR "$ORIGIN")
endif()

if(BUILD_SLEIGH_PLUGIN)
add_library(asm_ghidra SHARED ${ASM_SOURCE})
target_link_libraries(asm_ghidra core_ghidra)
set_target_properties(asm_ghidra PROPERTIES
		OUTPUT_NAME asm_ghidra
		BUILD_RPATH "${LD_RPATH_STR}"
		INSTALL_RPATH "${LD_RPATH_STR}"
		PREFIX "")

add_library(analysis_ghidra SHARED ${ANALYSIS_SOURCE})
target_link_libraries(analysis_ghidra core_ghidra)
set_target_properties(analysis_ghidra PROPERTIES
		OUTPUT_NAME analysis_ghidra
		BUILD_RPATH "${LD_RPATH_STR}"
		INSTALL_RPATH "${LD_RPATH_STR}"
		PREFIX "")
endif()

if(SLEIGHHOME_DEFAULT)
	target_compile_definitions(core_ghidra PRIVATE "-DRZ_GHIDRA_SLEIGHHOME_DEFAULT=\"${SLEIGHHOME_DEFAULT}\"")
	if(BUILD_SLEIGH_PLUGIN)
		target_compile_definitions(asm_ghidra PRIVATE "-DRZ_GHIDRA_SLEIGHHOME_DEFAULT=\"${SLEIGHHOME_DEFAULT}\"")
		target_compile_definitions(analysis_ghidra PRIVATE "-DRZ_GHIDRA_SLEIGHHOME_DEFAULT=\"${SLEIGHHOME_DEFAULT}\"")
	endif()
endif()

if(NOT DEFINED CMAKE_INSTALL_LIBDIR)
	set(CMAKE_INSTALL_LIBDIR lib CACHE PATH "Output directory for libraries.")
endif()

install(TARGETS core_ghidra DESTINATION "${RIZIN_INSTALL_PLUGDIR}")
if(BUILD_SLEIGH_PLUGIN)
install(TARGETS asm_ghidra DESTINATION "${RIZIN_INSTALL_PLUGDIR}")
install(TARGETS analysis_ghidra DESTINATION "${RIZIN_INSTALL_PLUGDIR}")
endif()
install(FILES ${PUBLIC_HEADERS} DESTINATION "${CMAKE_INSTALL_PREFIX}/include")
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/rz_ghidra.pc" DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig")

=== test/bins/Makefile ===

all:

.PHONY: clean
clean:
	rm -fv dectest32 dectest64 rec

dectest32: dectest.c types.h
	gcc -m32 -fno-pic -no-pie -fno-omit-frame-pointer -o dectest32 -O0 dectest.c

dectest32-sp: dectest.c types.h
	gcc -m32 -fno-pic -no-pie -fomit-frame-pointer -o dectest32-sp -O0 dectest.c

dectest64: dectest.c types.h
	gcc -m64 -fno-pic -no-pie -fno-omit-frame-pointer -o dectest64 -O0 dectest.c

dectest64-sp: dectest.c types.h
	gcc -m64 -fno-pic -no-pie -fomit-frame-pointer -o dectest64-sp -O0 dectest.c

rec: rec.c types_rec.h
	gcc -m64 -fno-pic -no-pie -fno-omit-frame-pointer -o rec -O0 rec.c

strings: strings.c
	gcc -m64 -fno-pic -no-pie -fno-omit-frame-pointer -o strings -O0 strings.c

=== debian/changelog ===
rizin-ghidra-plugin (0.7.0-1parrot1) stable; urgency=medium

  * New upstream version 0.7.0

 -- Nong Hoang Tu <dmknght@parrotsec.org>  Wed, 28 Feb 2024 15:53:33 +0700

rizin-ghidra-plugin (0.6.0-1parrot2) lory; urgency=medium

  * New update URL via github's api
  * Correct search mode for watch file

 -- Nong Hoang Tu <dmknght@parrotsec.org>  Wed, 07 Feb 2024 19:09:44 +0700

rizin-ghidra-plugin (0.6.0-1parrot1) parrot-updates; urgency=medium

  * New upstream version 0.6.0

 -- Nong Hoang Tu <dmknght@parrotsec.org>  Mon, 04 Sep 2023 05:18:49 +0700

rizin-ghidra-plugin (0.5.0-1parrot1) parrot-updates; urgency=medium

  * New upstream version 0.5.0

 -- Nong Hoang Tu <dmknght@parrotsec.org>  Tue, 28 Feb 2023 10:50:02 +0700

rizin-ghidra-plugin (0.4.0-0parrot9) parrot-updates; urgency=medium

  * Fix template file when build

 -- Nong Hoang Tu <dmknght@parrotsec.org>  Thu, 11 Aug 2022 22:20:01 +0700

rizin-ghidra-plugin (0.4.0-0parrot8) parrot-updates; urgency=medium

  * Fix tmp file exists when build in schroot

 -- Nong Hoang Tu <dmknght@parrotsec.org>  Tue, 09 Aug 2022 04:46:32 +0700

rizin-ghidra-plugin (0.4.0-0parrot7) parrot-updates; urgency=medium

  * Use automation build of Debian instead of define files manually

 -- Nong Hoang Tu <dmknght@parrotsec.org>  Tue, 09 Aug 2022 04:39:20 +0700

rizin-ghidra-plugin (0.4.0-0parrot6) parrot-updates; urgency=medium

  * Update changelog for 0.4.0-0parrot5 release
  * Fix install lib from tmp folder caused faild to install in schroot

 -- Nong Hoang Tu <dmknght@parrotsec.org>  Tue, 09 Aug 2022 03:15:42 +0700

rizin-ghidra-plugin (0.4.0-0parrot5) parrot-updates; urgency=medium

  * Fix missing rizin-cutter binary

 -- Nong Hoang Tu <dmknght@parrotsec.org>  Mon, 08 Aug 2022 21:49:37 +0700

rizin-ghidra-plugin (0.4.0-0parrot4) parrot-updates; urgency=medium

  * Add missing libqt5svg5-dev

 -- Nong Hoang Tu <dmknght@parrotsec.org>  Mon, 08 Aug 2022 21:35:46 +0700

rizin-ghidra-plugin (0.4.0-0parrot3) parrot-updates; urgency=medium

  * Use glob path installation

 -- Nong Hoang Tu <dmknght@parrotsec.org>  Tue, 12 Jul 2022 19:46:03 +0700

rizin-ghidra-plugin (0.4.0-0parrot2) parrot-updates; urgency=medium

  * New pkging structure

 -- Nong Hoang Tu <dmknght@parrotsec.org>  Tue, 05 Jul 2022 05:47:31 +0700

rizin-ghidra-plugin (0.4.0-0parrot1) parrot-updates; urgency=medium

  * Edit the extension to the latest that rizin-ghidra uses
  * New upstream version 0.4.0

 -- Nong Hoang Tu <dmknght@parrotsec.org>  Tue, 28 Jun 2022 18:36:54 +0700

rizin-ghidra-plugin (0.3.0-0parrot2) parrot-updates; urgency=medium

  * Remove template comments (fix dh_make_template warning)
  * Add descriptions for binary package
  * Correct value of Uploaders and Maintainer

 -- Nong Hoang Tu <dmknght@parrotsec.org>  Tue, 22 Mar 2022 20:27:43 +0700

rizin-ghidra-plugin (0.3.0-0parrot1) rolling-testing; urgency=medium

  * New upstream version 0.3.0

 -- Nong Hoang Tu <dmknght@parrotsec.org>  Sun, 26 Sep 2021 05:34:22 +0700

rizin-ghidra-plugin (0.2.0-0parrot6) rolling; urgency=medium

  * Rebuild package with newer rizin version.

 -- Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>  Fri, 07 May 2021 17:58:34 +0200

rizin-ghidra-plugin (0.2.0-0parrot5) rolling; urgency=medium

  * Rebuild package with newer rizin version.

 -- Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>  Thu, 29 Apr 2021 00:11:15 +0200

rizin-ghidra-plugin (0.2.0-0parrot4) rolling-testing; urgency=medium

  [ Nong Hoang Tu ]
  * Fix missing build dependencies.

 -- Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>  Sun, 11 Apr 2021 23:20:18 +0200

rizin-ghidra-plugin (0.2.0-0parrot3) rolling-testing; urgency=medium

  * Fix postinst problem when symlink exist

 -- Nong Hoang Tu <dmknght@parrotsec.org>  Sat, 10 Apr 2021 01:05:54 +0700

rizin-ghidra-plugin (0.2.0-parrot2) rolling-testing; urgency=medium

  * Remove ninja from depends
  * Complete the build rules for rizin 0.2.0
  * Solve the lib not found problem of cutter
  * Update the authors in copyright

 -- Nong Hoang Tu <dmknght@parrotsec.org>  Sat, 10 Apr 2021 00:55:41 +0700

rizin-ghidra-plugin (0.2.0-parrot1) rolling-testing; urgency=medium

  * Change target url to release version with sub module
  * New upstream version 0.2.0

 -- Nong Hoang Tu <dmknght@parrotsec.org>  Fri, 09 Apr 2021 18:04:07 +0700

rizin-ghidra-plugin (0.2.0-parrot0) rolling-testing; urgency=medium

  * Remove template files
  * Add first watch file
  * Fix regex that parses version
  * Fix regex branch format
  * New upstream version 0.2.0

 -- Nong Hoang Tu <dmknght@parrotsec.org>  Fri, 09 Apr 2021 17:56:54 +0700

rizin-ghidra-plugin (0.1.1-parrot0) unstable; urgency=medium

  * Initial release

 -- Nong Hoang Tu <dmknght@parrotsec.org>  Wed, 07 Apr 2021 20:15:58 +0700

=== debian/control ===
Source: rizin-ghidra-plugin
Section: utils
Priority: optional
Maintainer: Parrot Team <team@parrotsec.org>
Uploaders: Nong Hoang Tu <dmknght@parrotsec.org>
Build-Depends: debhelper-compat (= 13), librizin-dev, librizin-cutter-dev, cmake, pkg-config, qtbase5-dev, libqt5svg5-dev, rizin-cutter
Standards-Version: 4.5.1
Homepage: https://github.com/rizinorg/rz-ghidra/
Vcs-Browser: https://nest.parrotsec.org/packages/tools/rizin-ghidra-plugin
Vcs-Git: https://nest.parrotsec.org/packages/tools/rizin-ghidra-plugin.git
Rules-Requires-Root: no

Package: rizin-plugin-ghidra
Architecture: amd64
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: A fork of Ghidra's decompiler for Rizin and Cutter
 This is an integration of the Ghidra decompiler and Sleigh Disassembler
 for Rizin. It is solely based on the decompiler part of Ghidra, which is
 written entirely in C++, so Ghidra itself is not required at all and the
 plugin can be built self-contained.

## rizin-ghidra-plugin 0.8.0

=== debian/changelog ===
rizin-ghidra-plugin (0.8.0-0parrot2) echo; urgency=medium

  * Migrate dependencies to qt6

 -- Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>  Tue, 03 Feb 2026 22:46:59 +0100

rizin-ghidra-plugin (0.8.0-0parrot1) echo; urgency=medium

  * New upstream version 0.8.0

 -- Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>  Tue, 03 Feb 2026 18:12:39 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Parrot Team <team@parrotsec.org>
 Uploaders: Nong Hoang Tu <dmknght@parrotsec.org>
-Build-Depends: debhelper-compat (= 13), librizin-dev, librizin-cutter-dev, cmake, pkg-config, qtbase5-dev, libqt5svg5-dev, rizin-cutter
+Build-Depends: debhelper-compat (= 13), librizin-dev, librizin-cutter-dev, cmake, pkg-config, qt6-base-dev, qt6-tools-dev, qt6-svg-dev, libstdc++-14-dev, qt6-5compat-dev, rizin-cutter
 Standards-Version: 4.5.1
 Homepage: https://github.com/rizinorg/rz-ghidra/
 Vcs-Browser: https://nest.parrotsec.org/packages/tools/rizin-ghidra-plugin

=== debian/rules ===
#!/usr/bin/make -f


%:
	dh $@ --buildsystem=cmake -- DESTDIR=build
override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_CUTTER_PLUGIN=ON -DCUTTER_SOURCE_DIR=/usr/include/librz-cutter -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_PREFIX_PATH=/usr
override_dh_install:
	install $(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)/cutter-plugin/librz_ghidra_cutter.so $(CURDIR)/debian/rizin-plugin-ghidra/usr/share/rizin/cutter/plugins/native/
	dh_prep --exclude=rizin-plugin-ghidra
	rm -rf $(CURDIR)/debian/rizin-plugin-ghidra/tmp/

=== debian/watch ===
version=4

opts="searchmode=plain" https://api.github.com/repos/rizinorg/rz-ghidra/releases?per_page=1 https://github.com/rizinorg/rz-ghidra/releases/download/v[\d\.]*/rz-ghidra-src-v([\d\.]*)\.tar\.gz
